﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;
using Telerik.Windows.Controls;
using System.Text;

namespace SilverlightGridPrinting
{
    public partial class MainPage : UserControl
    {
        const string printScript = @"<script type=""text/javascript"">print();setTimeout(function(){close();}, 0);</script>";
        const string fileName = "Output.html";

        public MainPage()
        {
            InitializeComponent();
        }

        void RadGridView1_Exporting(object sender, GridViewExportEventArgs e)
        {
            if (e.Element == ExportElement.HeaderRow)
            {
                e.Height = 50;
                e.Background = Colors.Black;
                e.Foreground = Colors.White;
                e.FontSize = 20;
                e.FontWeight = FontWeights.Bold;
            }
            else if (e.Element == ExportElement.GroupHeaderRow)
            {
                e.FontFamily = new FontFamily("Verdana");
                e.Background = Colors.LightGray;
                e.Height = 30;
            }
        }

        private void DomainDataSource1_LoadingData(object sender, LoadingDataEventArgs e)
        {
            RadGridView1.IsBusy = true;
            Button1.IsEnabled = false;
        }

        private void DomainDataSource1_LoadedData(object sender, LoadedDataEventArgs e)
        {
            RadGridView1.IsBusy = false;
            Button1.IsEnabled = true;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Uri uri = new Uri(HtmlPage.Document.DocumentUri, String.Format("PrintHandler.aspx?FileName={0}", fileName));
            WebClient client = new WebClient();
            client.UploadStringCompleted += new UploadStringCompletedEventHandler(client_UploadStringCompleted);
            client.UploadStringAsync(uri, String.Format("{0}{1}", RadGridView1.ToHtml(), printScript));
        }

        void client_UploadStringCompleted(object sender, UploadStringCompletedEventArgs e)
        {
            HtmlPage.Window.Navigate(new Uri(HtmlPage.Document.DocumentUri, fileName), "_blank", "menubar=0;toolbar=0;fullscreen=1;");
        }
    }
}
